Browse Source

feat: update Dockerfile and entrypoint scripts

- Updated Dockerfiles for Ubuntu 18.04, 20.04, and 22.04 to use Node.js version 16.x instead of 18.x or 20.x
- Set environment variables LGSM_GITHUBBRANCH, LGSM_LOGDIR, LGSM_SERVERFILES, and LGSM_CONFIG to new values
- Changed working directory from /linuxgsm to /app
- Created /data directory in the container
- Cleared modules directory (/app/lgsm/modules) if branch is not master
pull/22/head
Daniel Gibbs 2 years ago
parent
commit
890f9cad1f
  1. 3
      .vscode/settings.json
  2. 37
      Dockerfile.ubuntu-1804
  3. 37
      Dockerfile.ubuntu-2004
  4. 32
      Dockerfile.ubuntu-2204
  5. 49
      entrypoint-user.sh
  6. 22
      entrypoint.sh

3
.vscode/settings.json

@ -0,0 +1,3 @@
{
"ansible.python.interpreterPath": "/bin/python3"
}

37
Dockerfile.ubuntu-1804

@ -11,7 +11,10 @@ ENV DEBIAN_FRONTEND noninteractive
ENV TERM=xterm
ENV LGSM_GITHUBUSER=GameServerManagers
ENV LGSM_GITHUBREPO=LinuxGSM
ENV LGSM_GITHUBBRANCH=develop
ENV LGSM_GITHUBBRANCH=hotfix/v23.3.5
ENV LGSM_LOGDIR=/data/log
ENV LGSM_SERVERFILES=/data/serverfiles
ENV LGSM_CONFIG=/data/config-lgsm
ENV GAMESERVER=jc2server
ENV UPDATE_CHECK=1800
ENV USERNAME=linuxgsm
@ -67,7 +70,7 @@ RUN echo "**** Install Base LinuxGSM Requirements ****" \
# Install Node.js
RUN echo "**** Install Node.js ****" \
&& curl -sL https://deb.nodesource.com/setup_18.x | bash - \
&& curl -sL https://deb.nodesource.com/setup_16.x | bash - \
&& apt-get update \
&& apt-get install -y nodejs \
&& apt-get -y autoremove \
@ -80,10 +83,11 @@ RUN echo "**** Install Node.js ****" \
RUN echo "**** Install GameDig ****" \
&& npm install -g gamedig
WORKDIR /linuxgsm
WORKDIR /app
## Add linuxgsm user
RUN echo "**** Add linuxgsm user ****" \
&& mkdir /data \
# Create the user
&& groupadd --gid $GID $USERNAME \
&& useradd --uid $UID --gid $GID -m $USERNAME \
@ -91,14 +95,13 @@ RUN echo "**** Add linuxgsm user ****" \
# [Optional] Add sudo support. Omit if you don't need to install software after connecting.
&& echo $USERNAME ALL=\(root\) NOPASSWD:ALL > /etc/sudoers.d/$USERNAME \
&& chmod 0440 /etc/sudoers.d/$USERNAME \
&& chown $USERNAME:$USERNAME /home/$USERNAME
&& chown $USERNAME:$USERNAME /data
HEALTHCHECK --interval=1m --timeout=1m --start-period=2m --retries=1 CMD /linuxgsm/entrypoint-healthcheck.sh || exit 1
HEALTHCHECK --interval=1m --timeout=1m --start-period=2m --retries=1 CMD /app/entrypoint-healthcheck.sh || exit 1
## Download linuxgsm.sh
RUN echo "**** Download linuxgsm.sh ****" \
&& set -ex \
&& mkdir -p /linuxgsm/lgsm \
&& wget -O linuxgsm.sh "https://raw.githubusercontent.com/GameServerManagers/LinuxGSM/${LGSM_GITHUBBRANCH}/linuxgsm.sh" \
&& chmod +x linuxgsm.sh
@ -106,17 +109,21 @@ RUN echo "**** Get LinuxGSM Modules ****" \
&& git clone --filter=blob:none --no-checkout --sparse https://github.com/GameServerManagers/LinuxGSM.git \
&& cd LinuxGSM \
&& git sparse-checkout set --cone \
&& git sparse-checkout set lgsm/functions \
&& git sparse-checkout set lgsm/modules \
&& git checkout ${LGSM_GITHUBBRANCH} \
&& mkdir -p /linuxgsm/lgsm/functions \
&& mv lgsm/functions/* /linuxgsm/lgsm/functions \
&& chmod +x /linuxgsm/lgsm/functions/* \
&& rm -rf /linuxgsm/LinuxGSM \
&& chown -R $USERNAME:$USERNAME /linuxgsm
&& mkdir -p /app/lgsm/modules \
&& mv lgsm/modules/* /app/lgsm/modules \
&& chmod +x /app/lgsm/modules/* \
&& cd ../ \
&& rm -rf LinuxGSM \
&& chown -R $USERNAME:$USERNAME /app
COPY entrypoint.sh /linuxgsm/entrypoint.sh
COPY entrypoint-user.sh /linuxgsm/entrypoint-user.sh
COPY entrypoint-healthcheck.sh /linuxgsm/entrypoint-healthcheck.sh
ARG CACHEBUST=1
RUN echo "$CACHEBUST"
COPY entrypoint.sh /app/entrypoint.sh
COPY entrypoint-user.sh /app/entrypoint-user.sh
COPY entrypoint-healthcheck.sh /app/entrypoint-healthcheck.sh
RUN date > /build-time.txt

37
Dockerfile.ubuntu-2004

@ -11,7 +11,10 @@ ENV DEBIAN_FRONTEND noninteractive
ENV TERM=xterm
ENV LGSM_GITHUBUSER=GameServerManagers
ENV LGSM_GITHUBREPO=LinuxGSM
ENV LGSM_GITHUBBRANCH=develop
ENV LGSM_GITHUBBRANCH=hotfix/v23.3.5
ENV LGSM_LOGDIR=/data/log
ENV LGSM_SERVERFILES=/data/serverfiles
ENV LGSM_CONFIG=/data/config-lgsm
ENV GAMESERVER=jc2server
ENV UPDATE_CHECK=1800
ENV USERNAME=linuxgsm
@ -67,7 +70,7 @@ RUN echo "**** Install Base LinuxGSM Requirements ****" \
# Install Node.js
RUN echo "**** Install Node.js ****" \
&& curl -sL https://deb.nodesource.com/setup_18.x | bash - \
&& curl -sL https://deb.nodesource.com/setup_20.x | bash - \
&& apt-get update \
&& apt-get install -y nodejs \
&& apt-get -y autoremove \
@ -80,10 +83,11 @@ RUN echo "**** Install Node.js ****" \
RUN echo "**** Install GameDig ****" \
&& npm install -g gamedig
WORKDIR /linuxgsm
WORKDIR /app
## Add linuxgsm user
RUN echo "**** Add linuxgsm user ****" \
&& mkdir /data \
# Create the user
&& groupadd --gid $GID $USERNAME \
&& useradd --uid $UID --gid $GID -m $USERNAME \
@ -91,14 +95,13 @@ RUN echo "**** Add linuxgsm user ****" \
# [Optional] Add sudo support. Omit if you don't need to install software after connecting.
&& echo $USERNAME ALL=\(root\) NOPASSWD:ALL > /etc/sudoers.d/$USERNAME \
&& chmod 0440 /etc/sudoers.d/$USERNAME \
&& chown $USERNAME:$USERNAME /home/$USERNAME
&& chown $USERNAME:$USERNAME /data
HEALTHCHECK --interval=1m --timeout=1m --start-period=2m --retries=1 CMD /linuxgsm/entrypoint-healthcheck.sh || exit 1
HEALTHCHECK --interval=1m --timeout=1m --start-period=2m --retries=1 CMD /app/entrypoint-healthcheck.sh || exit 1
## Download linuxgsm.sh
RUN echo "**** Download linuxgsm.sh ****" \
&& set -ex \
&& mkdir -p /linuxgsm/lgsm \
&& wget -O linuxgsm.sh "https://raw.githubusercontent.com/GameServerManagers/LinuxGSM/${LGSM_GITHUBBRANCH}/linuxgsm.sh" \
&& chmod +x linuxgsm.sh
@ -106,17 +109,21 @@ RUN echo "**** Get LinuxGSM Modules ****" \
&& git clone --filter=blob:none --no-checkout --sparse https://github.com/GameServerManagers/LinuxGSM.git \
&& cd LinuxGSM \
&& git sparse-checkout set --cone \
&& git sparse-checkout set lgsm/functions \
&& git sparse-checkout set lgsm/modules \
&& git checkout ${LGSM_GITHUBBRANCH} \
&& mkdir -p /linuxgsm/lgsm/functions \
&& mv lgsm/functions/* /linuxgsm/lgsm/functions \
&& chmod +x /linuxgsm/lgsm/functions/* \
&& rm -rf /linuxgsm/LinuxGSM \
&& chown -R $USERNAME:$USERNAME /linuxgsm
&& mkdir -p /app/lgsm/modules \
&& mv lgsm/modules/* /app/lgsm/modules \
&& chmod +x /app/lgsm/modules/* \
&& cd ../ \
&& rm -rf LinuxGSM \
&& chown -R $USERNAME:$USERNAME /app
COPY entrypoint.sh /linuxgsm/entrypoint.sh
COPY entrypoint-user.sh /linuxgsm/entrypoint-user.sh
COPY entrypoint-healthcheck.sh /linuxgsm/entrypoint-healthcheck.sh
ARG CACHEBUST=1
RUN echo "$CACHEBUST"
COPY entrypoint.sh /app/entrypoint.sh
COPY entrypoint-user.sh /app/entrypoint-user.sh
COPY entrypoint-healthcheck.sh /app/entrypoint-healthcheck.sh
RUN date > /build-time.txt

32
Dockerfile.ubuntu-2204

@ -11,7 +11,10 @@ ENV DEBIAN_FRONTEND noninteractive
ENV TERM=xterm
ENV LGSM_GITHUBUSER=GameServerManagers
ENV LGSM_GITHUBREPO=LinuxGSM
ENV LGSM_GITHUBBRANCH=develop
ENV LGSM_GITHUBBRANCH=hotfix/v23.3.5
ENV LGSM_LOGDIR=/data/log
ENV LGSM_SERVERFILES=/data/serverfiles
ENV LGSM_CONFIG=/data/config-lgsm
ENV GAMESERVER=jc2server
ENV UPDATE_CHECK=1800
ENV USERNAME=linuxgsm
@ -67,7 +70,7 @@ RUN echo "**** Install Base LinuxGSM Requirements ****" \
# Install Node.js
RUN echo "**** Install Node.js ****" \
&& curl -sL https://deb.nodesource.com/setup_18.x | bash - \
&& curl -sL https://deb.nodesource.com/setup_20.x | bash - \
&& apt-get update \
&& apt-get install -y nodejs \
&& apt-get -y autoremove \
@ -80,10 +83,11 @@ RUN echo "**** Install Node.js ****" \
RUN echo "**** Install GameDig ****" \
&& npm install -g gamedig
WORKDIR /linuxgsm
WORKDIR /app
## Add linuxgsm user
RUN echo "**** Add linuxgsm user ****" \
&& mkdir /data \
# Create the user
&& groupadd --gid $GID $USERNAME \
&& useradd --uid $UID --gid $GID -m $USERNAME \
@ -91,14 +95,13 @@ RUN echo "**** Add linuxgsm user ****" \
# [Optional] Add sudo support. Omit if you don't need to install software after connecting.
&& echo $USERNAME ALL=\(root\) NOPASSWD:ALL > /etc/sudoers.d/$USERNAME \
&& chmod 0440 /etc/sudoers.d/$USERNAME \
&& chown $USERNAME:$USERNAME /home/$USERNAME
&& chown $USERNAME:$USERNAME /data
HEALTHCHECK --interval=1m --timeout=1m --start-period=2m --retries=1 CMD /linuxgsm/entrypoint-healthcheck.sh || exit 1
HEALTHCHECK --interval=1m --timeout=1m --start-period=2m --retries=1 CMD /app/entrypoint-healthcheck.sh || exit 1
## Download linuxgsm.sh
RUN echo "**** Download linuxgsm.sh ****" \
&& set -ex \
&& mkdir -p /linuxgsm/lgsm \
&& wget -O linuxgsm.sh "https://raw.githubusercontent.com/GameServerManagers/LinuxGSM/${LGSM_GITHUBBRANCH}/linuxgsm.sh" \
&& chmod +x linuxgsm.sh
@ -108,18 +111,19 @@ RUN echo "**** Get LinuxGSM Modules ****" \
&& git sparse-checkout set --cone \
&& git sparse-checkout set lgsm/modules \
&& git checkout ${LGSM_GITHUBBRANCH} \
&& mkdir -p /linuxgsm/lgsm/modules \
&& mv lgsm/modules/* /linuxgsm/lgsm/modules \
&& chmod +x /linuxgsm/lgsm/modules/* \
&& rm -rf /linuxgsm/LinuxGSM \
&& chown -R $USERNAME:$USERNAME /linuxgsm
&& mkdir -p /app/lgsm/modules \
&& mv lgsm/modules/* /app/lgsm/modules \
&& chmod +x /app/lgsm/modules/* \
&& cd ../ \
&& rm -rf LinuxGSM \
&& chown -R $USERNAME:$USERNAME /app
ARG CACHEBUST=1
RUN echo "$CACHEBUST"
COPY entrypoint.sh /linuxgsm/entrypoint.sh
COPY entrypoint-user.sh /linuxgsm/entrypoint-user.sh
COPY entrypoint-healthcheck.sh /linuxgsm/entrypoint-healthcheck.sh
COPY entrypoint.sh /app/entrypoint.sh
COPY entrypoint-user.sh /app/entrypoint-user.sh
COPY entrypoint-healthcheck.sh /app/entrypoint-healthcheck.sh
RUN date > /build-time.txt

49
entrypoint-user.sh

@ -4,16 +4,16 @@ if [ ! -f "${GAMESERVER}" ]; then
echo -e ""
echo -e "creating ${GAMESERVER}"
echo -e "================================="
./linuxgsm.sh ${GAMESERVER}
./linuxgsm.sh "${GAMESERVER}"
fi
# Clear functions directory if not master
# Clear modules directory if not master
if [ "${LGSM_GITHUBBRANCH}" != "master" ]; then
echo -e "not master branch, clearing functions directory"
rm -rf /linuxgsm/lgsm/modules/*
elif [ -d "/linuxgsm/lgsm/modules" ]; then
echo -e "ensure all functions are executable"
chmod +x /linuxgsm/lgsm/modules/*
echo -e "not master branch, clearing modules directory"
rm -rf /app/lgsm/modules/*
elif [ -d "/app/lgsm/modules" ]; then
echo -e "ensure all modules are executable"
chmod +x /app/lgsm/modules/*
fi
# Install game server
@ -21,16 +21,16 @@ if [ -z "$(ls -A -- "serverfiles" 2> /dev/null)" ]; then
echo -e ""
echo -e "Installing ${GAMESERVER}"
echo -e "================================="
./${GAMESERVER} auto-install
./"${GAMESERVER}" auto-install
install=1
else
# Donate to display logo
./${GAMESERVER} sponsor
# Sponsor to display LinuxGSM logo
./"${GAMESERVER}" sponsor
fi
echo -e ""
echo -e "Starting Update Checks"
echo -e "================================="
nohup watch -n "${UPDATE_CHECK}" ./${GAMESERVER} update > /dev/null 2>&1 &
nohup watch -n "${UPDATE_CHECK}" ./"${GAMESERVER}" update > /dev/null 2>&1 &
echo -e "update will check every ${UPDATE_CHECK} minutes"
# Update game server
@ -38,35 +38,24 @@ if [ -z "${install}" ]; then
echo -e ""
echo -e "Checking for Update ${GAMESERVER}"
echo -e "================================="
./${GAMESERVER} update
./"${GAMESERVER}" update
fi
echo -e ""
echo -e "Starting ${GAMESERVER}"
echo -e "================================="
./${GAMESERVER} start
./"${GAMESERVER}" start
sleep 5
./${GAMESERVER} details
./"${GAMESERVER}" details
sleep 2
echo -e "Tail log files"
echo -e "================================="
tail -F log/*/*.log
# with no command, just spawn a running container suitable for exec's
if [ $# = 0 ]; then
tail -f /dev/null
echo "DOLLAR0 $0"
echo "DOLLAR1 $1"
if [ -n "$1" ]; then
exec "$@"
else
# execute the command passed through docker
"$@"
# if this command was a server start cmd
# to get around LinuxGSM running everything in
# tmux;
# we attempt to attach to tmux to track the server
# this keeps the container running
# when invoked via docker run
# but requires -it or at least -t
tmux set -g status off && tmux attach 2> /dev/null
tail -F log/*/*.log
fi
exec "$@"

22
entrypoint.sh

@ -3,7 +3,7 @@
exit_handler() {
# Execute the shutdown commands
echo -e "stopping ${GAMESERVER}"
exec gosu ${USERNAME} ./${GAMESERVER} stop
exec gosu "${USERNAME}" ./${GAMESERVER} stop
exitcode=$?
exit ${exitcode}
}
@ -27,6 +27,9 @@ echo -e ""
echo -e "LGSM_GITHUBUSER: ${LGSM_GITHUBUSER}"
echo -e "LGSM_GITHUBREPO: ${LGSM_GITHUBREPO}"
echo -e "LGSM_GITHUBBRANCH: ${LGSM_GITHUBBRANCH}"
echo -e "LGSM_LOGDIR: ${LGSM_LOGDIR}"
echo -e "LGSM_SERVERFILES: ${LGSM_SERVERFILES}"
echo -e "LGSM_CONFIG: ${LGSM_CONFIG}"
echo -e ""
echo -e "Initalising"
@ -35,23 +38,24 @@ echo -e "=======================================================================
export LGSM_GITHUBUSER=${LGSM_GITHUBUSER}
export LGSM_GITHUBREPO=${LGSM_GITHUBREPO}
export LGSM_GITHUBBRANCH=${LGSM_GITHUBBRANCH}
export LGSM_LOGDIR=${LGSM_LOGDIR}
export LGSM_SERVERFILES=${LGSM_SERVERFILES}
export LGSM_CONFIG=${LGSM_CONFIG}
cd /linuxgsm || exit
cd /app || exit
echo -e ""
echo -e "Check Permissions"
echo -e "================================="
echo -e "setting UID to ${UID}"
usermod -u ${UID} -m -d /linuxgsm linuxgsm > /dev/null 2>&1
usermod -u "${UID}" -m -d /data linuxgsm > /dev/null 2>&1
echo -e "setting GID to ${GID}"
groupmod -g ${GID} linuxgsm
groupmod -g "${GID}" linuxgsm
echo -e "updating permissions"
find /linuxgsm -user ${UID} -exec chown -h linuxgsm {} \;
find /linuxgsm -group ${GID} -exec chgrp -h linuxgsm {} \;
chown -R ${USERNAME}:${USERNAME} /linuxgsm
export HOME=/home/linuxgsm
chown -R "${USERNAME}":"${USERNAME}" /data
export HOME=/data
echo -e ""
echo -e "Switch to user ${USERNAME}"
echo -e "================================="
exec gosu ${USERNAME} /linuxgsm/entrypoint-user.sh
exec gosu "${USERNAME}" /app/entrypoint-user.sh

Loading…
Cancel
Save